#include <stdio.h>
#include <stdlib.h>

int main(int argc, char** argv) {

  int a[100];
  printf(" a:  %p\n &a: %p\n", a, &a);
  // (a) used as an expression treats it as a pointer.
  // For an array allocated on the stack, the array variable is a pointer to the array.
  // (&a) gets the address of the array

  int* p;
  printf(" p:  %p\n &p: %p\n", p, &p);
  // pointers on the stack are of course different. The pointer
  // declaration allocates memory only for a pointer, not for the data (the pointee)
}
